## openmpi 3.1.2

=== debian/changelog ===
openmpi (3.1.2-6) unstable; urgency=medium

  * Fixes for regression (segfaults in liggghts, etc) due to btl patch.
    Closes: #905418, #910263

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 08 Oct 2018 11:44:08 +0100

openmpi (3.1.2-5) unstable; urgency=medium

  * Fx by Nathan Hjelm for hangs on archs with 32-bit atomics tags
    Closes: #905418, #907267, #907407
  * make openmpi-bin depend on libopenmpi-dev, as its needed for mpicc,etc.
  * Drop link-libfabric.patch as obsolete

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 03 Oct 2018 13:15:03 +0100

openmpi (3.1.2-4) unstable; urgency=medium

  * Reccomend  libopencoarrays-openmpi-dev, (and drop opencoarrays-bin), now
    that coarrays pkg split to openmpi, mpich parts
  * Sanitize build paths from opal_config.h

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 18 Sep 2018 07:10:44 +0100

openmpi (3.1.2-3) unstable; urgency=medium

  * Regression: don't ship ompi_monitoring_prof.so in libopenmp3.
    Closes: #908503.
  * Standards-Version: 4.2.1. No changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 11 Sep 2018 11:44:22 +0100

openmpi (3.1.2-2) unstable; urgency=medium

  * Mark openmpi-common as M-A: foreign
  * Fix FTBFS with dpkg-buildpackage -A. Closes: #908148
  * Fix pmix dependency on -1 version to -1~.
  * Closing old bugs fixed in previous releases:
    Closes: #904779

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 07 Sep 2018 10:09:52 +0100

openmpi (3.1.2-1) unstable; urgency=medium

  * New upstream release
   - library changes:
     libmpi_mpifh.so.40.10.1 -> libmpi_mpifh.so.40.10.2
     libmpi.so.40.10.1 -> libmpi.so.40.10.2
     libopen-pal.so.40.10.1 -> libopen-pal.so.40.10.2
     libopen-rte.so.40.10.1 -> libopen-rte.so.40.10.2
   - hang-fix patch merged upstream
  * Re-enable use of external libpix, libevent
  * Add Recommends: on open-coarrays (dev and bin packages)

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 28 Aug 2018 19:07:54 +0100

openmpi (3.1.1.real-7) unstable; urgency=medium

  * Patch from upstream for OMPI/PMIX hang. Closes: #906118
  * Change openmpi-common to Arch: all
  * Standards-Version: 4.2.0

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 19 Aug 2018 19:06:13 +0100

openmpi (3.1.1.real-6) unstable; urgency=medium

  * Typo on d/control Breaks. pmix-dev -> pmix2

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 09 Aug 2018 15:02:02 +0100

openmpi (3.1.1.real-5) unstable; urgency=medium

  * Include zlib1g-dev to build against
  * Use internal libpmix, libevent to fix hang on MPI_Abort. 
    Closes: #904825.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 09 Aug 2018 12:55:50 +0100

openmpi (3.1.1.real-4) unstable; urgency=medium

  * Make libopenmpi3 pull in libpmix2 >= 3.0.0-1

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 18 Jul 2018 11:20:16 +0100
 

openmpi (3.1.1.real-3) unstable; urgency=medium
 
  * Patch ext2x to use pmix 3.0 
    Closes: #903561, #903492, #903549, #903655
  * Fix broken symlinks for libmpi_usempif08  

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 14 Jul 2018 13:47:37 +0100

openmpi (3.1.1.real-2) unstable; urgency=medium

  * Use internal pmix (2.1.2rc1) not external which is currently
    incompatible. Closes: #903596
  * Standards-Version: 4.1.5

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 12 Jul 2018 07:18:14 +0100

openmpi (3.1.1.real-1) unstable; urgency=medium

  * Real upstream 3.1.1 release (previous was a mislabelled 3.1.1rc2)

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 02 Jul 2018 16:14:02 +0100

openmpi (3.1.1-1) unstable; urgency=medium

  * New upstream release
  * Depend on pmix >= 2.1.2rc1

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 01 Jul 2018 17:12:05 +0100

openmpi (3.1.1~git.20180627-1) experimental; urgency=medium

  * Nightly tarball to test fix for armel
  * Update soversions:
     libmpi_mpifh.so.40.10.1
     libmpi.so.40.10.1
     libmpi_usempif08.so.40.10.1
     libmpi_usempi_ignore_tkr.so.40.10.1
     libopen-pal.so.40.10.1
     libopen-rte.so.40.10.1
  * mpi*-wrapper-data.txt is arch-dependent, so:
     Set openmpi-common as Arch: any, not all
     Drop M-A: foreign from openmpi-bin (which uses it)

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 27 Jun 2018 15:53:25 +0100

openmpi (3.1.0-8) unstable; urgency=medium

  * Remove powerpc build patch; now obsoleted upstream
  * Remove arm64 build patch; now obsoleted upstream

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 22 Jun 2018 12:26:38 +0100

openmpi (3.1.0-7) unstable; urgency=medium

  * Enable libpsm2.  Closes: #901132

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 09 Jun 2018 13:36:15 +0100

openmpi (3.1.0-6) unstable; urgency=medium

  * Dump libtool on FTBFS for debugging
  * Remove -rpath from compiler wrappers,too: Closes: #900069

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 28 May 2018 19:46:30 +0100

openmpi (3.1.0-5) unstable; urgency=medium

  * Fix overly strong dependencies on openmpi-bin causing upgrade issues.
    Closes: #899388
  * Remove -rpath flags from pkgconfig files. Closes: #899391
  * Add --with-package-string to configure for reproducibility

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 25 May 2018 10:15:38 +0100

openmpi (3.1.0-4) unstable; urgency=medium

  * Patch to fix underlinking. Closes: #899104

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 23 May 2018 15:47:13 +0100

openmpi (3.1.0-3) unstable; urgency=medium

  * libmca_common_ofi, monitoring: handle with being arch-dependent.
    Closes: 899169

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 20 May 2018 20:08:01 +0100

openmpi (3.1.0-2) unstable; urgency=medium

  * Include new libs libmca_common_monitoring, ofi. Closes: #899077

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 19 May 2018 08:20:20 +0100

openmpi (3.1.0-1) unstable; urgency=medium

  * New upstream release
   - Java support re-enabled; 
   - PPC patch no longer needed


=== debian/control ===
Source: openmpi
Section: net
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Uploaders: Debian Open MPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>,
 Manuel Prinz <manuel@debian.org>
Build-Depends: dpkg-dev (>= 1.16.1~), 
 debhelper (>= 11), 
 libltdl-dev,
 libevent-dev,
 libpmix-dev (>= 3.0.1-1~),
 zlib1g-dev,
 gfortran, gcc (>= 4:5.2.1), 
 chrpath, 
 libhwloc-dev,
 pkg-config,
 libibverbs-dev (>= 1.1.7) [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386],
 libfabric-dev [amd64 i386],
 libpsm-infinipath1-dev [amd64 i386],
 libpsm2-dev [amd64],
 libnuma-dev [amd64 i386 ia64 mips mipsel mipsn32 mipsn32el mips64 mips64el ppc64el],
 default-jdk [!hppa !hurd-i386 !ia64 !riscv64] <!stage1>,
 flex
Build-Conflicts: libmpich-dev, libopenmpi-dev
Standards-Version: 4.2.1
Homepage: https://www.open-mpi.org/
Vcs-Browser: https://salsa.debian.org/hpc-team/openmpi
Vcs-Git: https://salsa.debian.org/hpc-team/openmpi.git -b debian/master

Package: openmpi-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openmpi-common (>= ${source:Version}),
 openssh-client | ssh-client
Conflicts: openmpi-bin
Requires: libopenmpi-dev
Breaks: libopenmpi-dev (<< 3.0.1~rc2-2)
Replaces: libopenmpi-dev (<< 3.0.1~rc2-2)
Suggests: gfortran
Description: high performance message passing library -- binaries
 Open MPI is a project combining technologies and resources from several other
 projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best
 MPI library available. A completely new MPI-3.1 compliant implementation, Open
 MPI offers advantages for system and software vendors, application developers
 and computer science researchers.
 .
 Features:
  * Full MPI-3.1 standards conformance
  * Thread safety and concurrency
  * Dynamic process spawning
  * High performance on all platforms
  * Reliable and fast job management
  * Network and process fault tolerance
  * Support network heterogeneity
  * Single library supports all networks
  * Run-time instrumentation
  * Many job schedulers supported
  * Internationalized error messages
  * Component-based design, documented APIs
 .
 This package contains the Open MPI utility programs.

Package: libopenmpi-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, 
 libopenmpi3 (= ${binary:Version}), 
 openmpi-common (>= ${source:Version}), 
 libibverbs-dev (>= 1.1.7) [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386], libhwloc-dev,
 openmpi-bin (>= 3.0.0-1)
Recommends: libcoarrays-openmpi-dev
Conflicts: libopenmpi-dev
Breaks: openmpi-bin (<< 3.0.1~rc2-2)
Suggests: openmpi-doc
Description: high performance message passing library -- header files
 Open MPI is a project combining technologies and resources from several other
 projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best
 MPI library available. A completely new MPI-3 compliant implementation, Open
 MPI offers advantages for system and software vendors, application developers
 and computer science researchers.
 .
 This package contains the header files and compiler wrappers which are needed
 to compile and link programs against libopenmpi.

Package: libopenmpi3
Section: libs
Architecture: any
Recommends: openmpi-bin
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libhwloc-plugins, libpmix2 (>= 3.0.1-2)
Breaks: libpmix2 (<< 3.0.0-2)
Replaces: libpmix2 (<< 3.0.0-2)
Description: high performance message passing library -- shared library
 Open MPI is a project combining technologies and resources from several other
 projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best
 MPI library available. A completely new MPI-3.1 compliant implementation, Open
 MPI offers advantages for system and software vendors, application developers
 and computer science researchers.
 .
 This package contains the Open MPI shared libraries.

Package: openmpi-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Conflicts: openmpi-common
Description: high performance message passing library -- common files
 Open MPI is a project combining technologies and resources from several other
 projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best
 MPI library available. A completely new MPI-3.1 compliant implementation, Open
 MPI offers advantages for system and software vendors, application developers
 and computer science researchers.
 .
 This package contains platform independent files for Open MPI.

Package: openmpi-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Conflicts: mpi-doc, lam-mpidoc, lam4-dev, openmpi-doc
Replaces: openmpi-checkpoint (<< 1.10.2)
Breaks: openmpi-checkpoint (<< 1.10.2)
Description: high performance message passing library -- man pages
 Open MPI is a project combining technologies and resources from several other
 projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best
 MPI library available. A completely new MPI-3.1 compliant implementation, Open
 MPI offers advantages for system and software vendors, application developers
 and computer science researchers.
 .
 This package contains man pages describing the Message Passing Interface
 standard.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

DEBIAN_VERSION=$(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\-.*\)/\1/p' | sed -e 's/\+.*//; s/^[0-9]://')

DESTDIR:=`pwd`/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
AUTOGENERATED:= libopenmpi3.links libopenmpi-dev.links libopenmpi-dev.postinst \
  libopenmpi-dev.prerm openmpi-bin.preinst libopenmpi-dev.preinst

### Arch-specific stuff
# No ibverbs support available on kFreeBSD, Hurd
NO_VERBS_ARCH:= hurd-i386 kfreebsd-amd64 kfreebsd-i386 s390x 
FABRIC_ARCH:= amd64 i386 
PSM_ARCH:= amd64 i386
PSM2_ARCH:= amd64
BUILTIN_ATOMICS_ARCH:= s390x
NO_CMA_ARCH:= s390x mipsel hppa alpha armhf armel m68k sparc64
NO_JAVA_ARCH:= hppa hurd-i386 ia64 riscv64
NO_TEST_ARCH:= hppa hurd-i386

ifeq (sparc,$(DEB_HOST_GNU_CPU))
	CFLAGS += -mcpu=v9
endif

# Use -O3 recommended by upstream
CFLAGS += -O3
CXXFLAGS += -O3
FCFLAGS += -O3

ifeq ($(filter $(NO_VERBS_ARCH),$(DEB_HOST_ARCH)),)
	VERBS := --with-verbs
endif	
ifneq ($(filter $(BUILTIN_ATOMICS_ARCH),$(DEB_HOST_ARCH)),)
	ENABLE_BUILTIN_ATOMICS:= --enable-builtin-atomics
endif
ifneq ($(filter $(FABRIC_ARCH),$(DEB_HOST_ARCH)),)
	FABRIC := --with-libfabric
endif
ifneq ($(filter $(PSM_ARCH),$(DEB_HOST_ARCH)),)
	PSM:= --with-psm
endif
ifneq ($(filter $(PSM2_ARCH),$(DEB_HOST_ARCH)),)
	PSM:= --with-psm2
endif
ifeq ($(filter $(NO_JAVA_ARCH),$(DEB_HOST_ARCH)),)
ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
	JAVA := --with-jdk-dir=/usr/lib/jvm/default-java --enable-mpi-java
endif
endif
ifneq (,$(findstring $(DEB_HOST_ARCH),$(NO_TEST_ARCH)))
	DO_TEST := false
	BTL_TESTS := 
else
	DO_TEST := true
	BTL_TESTS:= --enable-opal-btl-usnic-unit-tests
endif
ifneq ($(filter $(NO_CMA_ARCH),$(DEB_HOST_ARCH)),)
	CMA:= --without-cma
endif

# Flags for the static build: see bug #502232
#STATIC_CONFIG_PARAMS = --enable-static
STATIC_CONFIG_PARAMS =  


%:
	dh $@ --no-parallel

override_dh_auto_clean:
	dh_clean
	find . -name .libs -exec rm -rf {} \; || true
	find . -name .dirstamp -delete
	find . -type l -delete
	find . -name '*.o' -delete
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})

override_dh_update_autotools_config:
	(cd config && autom4te --language=m4sh opal_get_version.m4sh -o opal_get_version.sh)
	./autogen.pl --force

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@TRIPLET@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	dh_auto_configure -- \
		--disable-silent-rules \
		--disable-wrapper-runpath \
		--with-package-string="Debian OpenMPI" \
		$(VERBS) $(FABRIC) $(PSM) $(PSM2) $(CMA) $(PMIX) \
		$(ENABLE_BUILTIN_ATOMICS) \
		$(JAVA) \
		$(STATIC_CONFIG_PARAMS) \
		$(BTL_TESTS) \
                --with-libevent=external \
                --with-pmix=${LIBDIR}/pmix \
		--disable-silent-rules \
		--enable-mpi-cxx \
		--with-hwloc=/usr  \
		--with-libltdl \
		--with-devel-headers \
		--with-slurm \
		--with-sge \
		--without-tm \
		--sysconfdir=/etc/openmpi 		\
		--libdir=\$${prefix}/lib/${DEB_HOST_MULTIARCH}/openmpi/lib	\
		--includedir=\$${prefix}/lib/${DEB_HOST_MULTIARCH}/openmpi/include 

# Extra debugging for non-deterministic FTBFS on some archs
override_dh_auto_build:
	dh_auto_build || ( \
		cat config.log ; \
		cat libtool ; \
		find . -name '*.la' -exec cat {} \; \
		)

override_dh_install:
	# Strip rpath info from all executables and libraries.
	find debian/tmp/ -type f -perm -+x -a ! -name '*.la' -a ! -name '*.mod' -exec chrpath -d '{}' \;
# Rename the compiler and startup wrappers.
	for f in mpic++ mpicc mpiCC mpicxx mpiexec mpif77 mpif90 mpirun mpifort ; do \
		if test -f debian/tmp/usr/bin/$${f}; then \
			mv debian/tmp/usr/bin/$${f} debian/tmp/usr/bin/$${f}.openmpi ; \
		fi; \
	done
# Strip rpath from pc,wrapper files
	for f in ompi-c.pc  ompi-cxx.pc  ompi-f77.pc  ompi-f90.pc  ompi-fort.pc  ompi.pc  opal.pc  orte.pc ; do  \
		sed -e 's/-Wl,-rpath -Wl,$${libdir}//' < $(DESTDIR)/$(LIBDIR)/openmpi/lib/pkgconfig/$${f} > debian/tmp.x ; \
		mv debian/tmp.x $(DESTDIR)/$(LIBDIR)/openmpi/lib/pkgconfig/$${f} ; \
		done
	find . -name '*wrapper-data.txt' | while read f; do \
		sed -e 's/-Wl,-rpath -Wl,@{libdir}//' < $$f > debian/tmp.x ; \
		mv debian/tmp.x $$f ; done
# Rename the compiler wrapper man pages.
	for f in mpic++ mpicc mpicxx mpiexec mpif77 mpif90 mpirun mpifort ; do \
		if test -f debian/tmp/usr/share/man/man1/$${f}.1; then \
			mv debian/tmp/usr/share/man/man1/$${f}.1 debian/tmp/usr/share/man/man1/$${f}.openmpi.1 ; \
		fi; \
		if test -f debian/tmp/usr/share/man/man1/$${f}.3; then \
			mv debian/tmp/usr/share/man/man3/$${f}.3 debian/tmp/usr/share/man/man1/$${f}.openmpi.3 ; \
		fi; \
	done
	cd debian/tmp/usr/share/man/man3; \
	for f in *.3; do \
		mv $$f $$(echo $$f|sed -e "s|\.3|.openmpi.3|g"); \
	done; \
# Rename orte-bootproxy.sh to orte-bootproxy
	if test -f debian/tmp/usr/bin/orte-bootproxy.sh; then \
		mv debian/tmp/usr/bin/orte-bootproxy.sh debian/tmp/usr/bin/orte-bootproxy; \
	fi
# Remove dangling symlink(s)
	rm -f debian/tmp/usr/share/man/man1/mpiCC.1
	rm -f debian/tmp/usr/share/man/man1/orteCC.1
# Remove COPYRIGHT file of ptmalloc2. It's reproduced in debian/copyright.
	rm -f -r debian/tmp/usr/share/openmpi/doc/
# Remove pmi2, pmix now in separate package
	rm -rf debian/tmp/usr/lib/*/openmpi/include/pmi*
# Remove buggy ${pkgincludedir} refs from pkg-config files. #837062
	find . -name '*.pc' | while read f ; do \
		cat $${f} | sed -e 's%-I$${pkgincludedir}[a-zA-Z0-9/]* %%g' > x ; \
		 mv x $${f}; done
# sanitize build paths for bit-reproducibility
	if test ./debian/tmp/${LIBDIR}/openmpi/include/openmpi/opal_config.h ; then \
		sed -e 's%${CURDIR}%/build/openmpi%g' < ./debian/tmp/${LIBDIR}/openmpi/include/openmpi/opal_config.h \
			> debian/tmp/x ; \
		mv debian/tmp/x ./debian/tmp/${LIBDIR}/openmpi/include/openmpi/opal_config.h ; \
	fi
# Continue as usual
	dh_install
# oshmem, shmem only built on Linux so do by hand or it may fail ...
	mkdir -p debian/libopenmpi3/${LIBDIR}/openmpi/lib 
	if test -f debian/tmp/usr/bin/oshmem_info ; then \
		mkdir -p debian/openmpi-bin/usr/share/man/man1 ; \
		cp -a debian/tmp/usr/bin/oshrun  debian/openmpi-bin//usr/bin/ ; \
		cp -a debian/tmp/usr/bin/oshmem_info  debian/openmpi-bin//usr/bin/ ; \
		cp -a debian/tmp/usr/bin/oshcc	 debian/libopenmpi-dev/usr/bin   ; \
		cp -a debian/tmp/usr/bin/oshfort   debian/libopenmpi-dev/usr/bin   ; \
		cp -a debian/tmp/${LIBDIR}/openmpi/lib/liboshmem.so.40.10.1 debian/libopenmpi3/${LIBDIR}/openmpi/lib ; \
		cp -a debian/tmp/usr/share/man/man1/oshcc.1 debian/libopenmpi-dev/usr/share/man/man1 ; \
		cp -a debian/tmp/usr/share/man/man1/oshfort.1 debian/libopenmpi-dev/usr/share/man/man1 ; \
		cp -a debian/tmp/usr/share/man/man1/oshrun.1 debian/openmpi-bin/usr/share/man/man1 ; \
		cp -a debian/tmp/usr/share/man/man1/oshmem_info.1 debian/openmpi-bin/usr/share/man/man1 ; \
		dh_link -p libopenmpi-dev	${LIBDIR}/liboshmem.so.40  ${LIBDIR}/liboshmem.so ; \
		dh_link -p libopenmpi3 ${LIBDIR}/openmpi/lib/liboshmem.so.40.10.1  ${LIBDIR}/liboshmem.so.40 ; \
	fi
	if test -f debian/tmp/${LIBDIR}/openmpi/lib/libmpi_java.so.40.10.0 ; then \
		cp -a debian/tmp/${LIBDIR}/openmpi/lib/libmpi_java.so.40.10.0 \
			debian/libopenmpi3/${LIBDIR}/openmpi/lib/libmpi_java.so.40.10.0 ; \
		dh_link -p libopenmpi3 ${LIBDIR}/libmpi_java.so.40.10.0  ${LIBDIR}/libmpi_java.so.40 ; \
		dh_link -p libopenmpi3 ${LIBDIR}/openmpi/lib/libmpi_java.so.40.10.0 ${LIBDIR}/libmpi_java.so.40.10.0 ; \
		dh_link -p libopenmpi-dev ${LIBDIR}/libmpi_java.so.40	${LIBDIR}/libmpi_java.so ; \
	fi
	if test -f debian/tmp/${LIBDIR}/openmpi/lib/libmca_common_monitoring.so.50.0.0 ; then  \
		cp -a debian/tmp/${LIBDIR}/openmpi/lib/libmca_common_monitoring.so.50.0.0 \
			debian/libopenmpi3/${LIBDIR}/openmpi/lib/libmca_common_monitoring.so.50.0.0 ; \

## openmpi 3.1.3

=== examples/Makefile ===
#
# Copyright (c) 2004-2005 The Trustees of Indiana University and Indiana
#                         University Research and Technology
#                         Corporation.  All rights reserved.
# Copyright (c) 2004-2005 The University of Tennessee and The University
#                         of Tennessee Research Foundation.  All rights
#                         reserved.
# Copyright (c) 2004-2005 High Performance Computing Center Stuttgart,
#                         University of Stuttgart.  All rights reserved.
# Copyright (c) 2004-2005 The Regents of the University of California.
#                         All rights reserved.
# Copyright (c) 2006-2007 Sun Microsystems, Inc.  All rights reserved.
# Copyright (c) 2011-2016 Cisco Systems, Inc.  All rights reserved.
# Copyright (c) 2012      Los Alamos National Security, Inc.  All rights reserved.
# Copyright (c) 2013      Mellanox Technologies, Inc.  All rights reserved.
# Copyright (c) 2017      Research Organization for Information Science
#                         and Technology (RIST). All rights reserved.
# $COPYRIGHT$
#
# Additional copyrights may follow
#
# $HEADER$
#

# Use the Open MPI-provided wrapper compilers.

MPICC = mpicc
MPICXX = mpic++
MPIFC = mpifort
MPIJAVAC = mpijavac
SHMEMCC = shmemcc
SHMEMCXX = shmemc++
SHMEMFC = shmemfort

# Using -g is not necessary, but it is helpful for example programs,
# especially if users want to examine them with debuggers.  Note that
# gmake requires the CXXFLAGS macro, while other versions of make
# (such as Sun's make) require the CCFLAGS macro.

CFLAGS += -g
CXXFLAGS += -g
CCFLAGS += -g
FCFLAGS += -g

# Example programs to build

EXAMPLES = \
	 hello_c \
	 hello_cxx \
	 hello_mpifh \
	 hello_usempi \
	 hello_usempif08 \
	 hello_oshmem \
	 hello_oshmemcxx \
	 hello_oshmemfh \
	 Hello.class \
	 ring_c \
	 ring_cxx \
	 ring_mpifh \
	 ring_usempi \
	 ring_usempif08 \
	 ring_oshmem \
	 ring_oshmemfh \
	 Ring.class \
	 connectivity_c \
	 oshmem_shmalloc \
	 oshmem_circular_shift \
	 oshmem_max_reduction \
	 oshmem_strided_puts \
	 oshmem_symmetric_data


# Default target.  Always build the C MPI examples.  Only build the
# others if we have the appropriate Open MPI / OpenSHMEM language
# bindings.

all: hello_c ring_c connectivity_c
	@ if which ompi_info >/dev/null 2>&1 ; then \
	    $(MAKE) mpi; \
	fi
	@ if which oshmem_info >/dev/null 2>&1 ; then \
	    $(MAKE) oshmem; \
	fi

# MPI examples

mpi:
	@ if ompi_info --parsable | grep -q bindings:cxx:yes >/dev/null; then \
	    $(MAKE) hello_cxx ring_cxx; \
	fi
	@ if ompi_info --parsable | grep -q bindings:mpif.h:yes >/dev/null; then \
	    $(MAKE) hello_mpifh ring_mpifh; \
	fi
	@ if ompi_info --parsable | egrep -q bindings:use_mpi:\"\?yes >/dev/null; then \
	    $(MAKE) hello_usempi ring_usempi; \
	fi
	@ if ompi_info --parsable | grep -q bindings:use_mpi_f08:yes >/dev/null; then \
	    $(MAKE) hello_usempif08 ring_usempif08; \
	fi
	@ if ompi_info --parsable | grep -q bindings:java:yes >/dev/null; then \
	    $(MAKE) Hello.class Ring.class; \
	fi

# OpenSHMEM examples

oshmem:
	@ if oshmem_info --parsable | grep oshmem:bindings:c:yes >/dev/null; then \
	    $(MAKE) hello_oshmem; \
	    $(MAKE) hello_oshmemcxx; \
	    $(MAKE) ring_oshmem; \
	    $(MAKE) oshmem_shmalloc; \
	    $(MAKE) oshmem_circular_shift; \
	    $(MAKE) oshmem_max_reduction; \
	    $(MAKE) oshmem_strided_puts; \
	    $(MAKE) oshmem_symmetric_data; \
	fi
	@ if oshmem_info --parsable | grep oshmem:bindings:fort:yes >/dev/null; then \
	    $(MAKE) hello_oshmemfh; \
	    $(MAKE) ring_oshmemfh; \
	fi

# The usual "clean" target

clean:
	rm -f $(EXAMPLES) *~ *.o

# Don't rely on default rules for the Fortran and Java examples

hello_c: hello_c.c
	$(MPICC) $(CFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@
ring_c: ring_c.c
	$(MPICC) $(CFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@
connectivity_c: connectivity_c.c
	$(MPICC) $(CFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@

hello_cxx: hello_cxx.cc
	$(MPICXX) $(CXXFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@
ring_cxx: ring_cxx.cc
	$(MPICXX) $(CXXFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@

hello_mpifh: hello_mpifh.f
	$(MPIFC) $(FCFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@
ring_mpifh: ring_mpifh.f
	$(MPIFC) $(FCFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@

hello_usempi: hello_usempi.f90
	$(MPIFC) $(FCFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@
ring_usempi: ring_usempi.f90
	$(MPIFC) $(FCFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@

hello_usempif08: hello_usempif08.f90
	$(MPIFC) $(FCFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@
ring_usempif08: ring_usempif08.f90
	$(MPIFC) $(FCFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@

Hello.class: Hello.java
	$(MPIJAVAC) Hello.java
Ring.class: Ring.java
	$(MPIJAVAC) Ring.java

hello_oshmem: hello_oshmem_c.c
	$(SHMEMCC) $(CFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@
hello_oshmemcxx: hello_oshmem_cxx.cc
	$(SHMEMCXX) $(CXXFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@
hello_oshmemfh: hello_oshmemfh.f90
	$(SHMEMFC) $(FCFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@

ring_oshmem: ring_oshmem_c.c
	$(SHMEMCC) $(CFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@
ring_oshmemfh: ring_oshmemfh.f90
	$(SHMEMFC) $(FCFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@

oshmem_shmalloc: oshmem_shmalloc.c
	$(SHMEMCC) $(CFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@

oshmem_circular_shift: oshmem_circular_shift.c
	$(SHMEMCC) $(CFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@

oshmem_max_reduction: oshmem_max_reduction.c
	$(SHMEMCC) $(CFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@

oshmem_strided_puts: oshmem_strided_puts.c
	$(SHMEMCC) $(CFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@

oshmem_symmetric_data: oshmem_symmetric_data.c
	$(SHMEMCC) $(CFLAGS) $(LDFLAGS) $? $(LDLIBS) -o $@

=== orte/test/mpi/Makefile ===
PROGS = mpi_no_op mpi_barrier hello hello_nodename abort multi_abort simple_spawn \
		concurrent_spawn spawn_multiple mpi_spin delayed_abort loop_spawn loop_child \
		bad_exit pubsub hello_barrier segv accept connect hello_output hello_show_help \
		crisscross read_write ziatest slave reduce-hang ziaprobe ziatest bcast_loop \
		parallel_w8 parallel_w64 parallel_r8 parallel_r64 sio sendrecv_blaster early_abort \
		debugger singleton_client_server intercomm_create spawn_tree init-exit77 mpi_info \
		info_spawn server client paccept pconnect ring hello.sapp binding badcoll attach xlib \
		no-disconnect nonzero interlib pinterlib add_host

all: $(PROGS)

# These guys need additional -I flags

hello_output: hello_output.c
	$(CC) $(CFLAGS) $(CFLAGS_INTERNAL) $^ -o $@

hello_show_help: hello_show_help.c
	$(CC) $(CFLAGS) $(CFLAGS_INTERNAL) $^ -o $@

xlib: xlib.c
	$(CC) $(CFLAGS) $(CFLAGS_INTERNAL) $^ -o $@ -lpmix

CC = mpicc
CFLAGS = -g --openmpi:linkall
CFLAGS_INTERNAL = -I../../.. -I../../../orte/include -I../../../opal/include
CXX = mpic++ --openmpi:linkall
CXXFLAGS = -g
FC = mpifort -openmpi:linkall
FCFLAGS = -g

clean:
	rm -f $(PROGS) *~

=== opal/mca/pmix/pmix2x/pmix/contrib/perf_tools/Makefile ===
PMIX_BASE = <pmix-path>
PMIX_INC= -I$(PMIX_BASE)/include/
PMIX_LIB= -L$(PMIX_BASE)/lib/ -lpmix

PMI2_BASE = /usr/
#PMI2_INC= -I$(PMI2_BASE)/include/
#PMI2_LIB= -L$(PMI2_BASE)/lib/ -lpmi2
PMI2_LIB= -lpmi2

CFLAGS = -O2 -g

all: pmix pmi2

pmix: pmi_intra_perf.c pmi.h pmix.c
	gcc $(PMIX_INC) $(CFLAGS) -o pmix_intra_perf pmi_intra_perf.c pmix.c $(PMIX_LIB) -lrt

pmi2: pmi_intra_perf.c pmi.h pmi2.c pmi2_pmap_parser.c pmi2_pmap_parser.h pmi2_utils.c pmi2_utils.h
	gcc $(PMI2_INC) $(CFLAGS) -o pmi2_intra_perf pmi_intra_perf.c pmi2.c pmi2_utils.c pmi2_pmap_parser.c -lrt $(PMI2_LIB)

clean:
	rm -f pmix_intra_perf pmi2_intra_perf

=== debian/changelog ===
openmpi (3.1.3-11) unstable; urgency=medium

  [ Alastair McKinstry ]
  * Build-Depend on gfortran | fortran-compiler
  * Drop B-D on gcc >= 4, obsolete
  * Drop -g flag if compiling with flang

  [ Andreas Beckmann ]
  * Team upload.
  * Add Breaks against mpich and lam predating mpi-$MULTIARCH alternatives.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 30 Apr 2019 23:40:47 +0200

openmpi (3.1.3-10) unstable; urgency=medium

  * Remove obsolete debian/TODO comments
  * Include cleanups of alternatives handling by Andreas Beckmann.
    Closes: #915025
  * Add Breaks: libmpich-dev (<< 3.3~b1-5) to libopenmpi-dev as the mpi
    alternatives handling changed.

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 20 Jan 2019 13:12:03 +0000

openmpi (3.1.3-9) unstable; urgency=medium

  * Re-enable external pmix now that it works with 32-bit systems again.
    Closes: #918713.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 08 Jan 2019 19:20:33 +0000

openmpi (3.1.3-8) unstable; urgency=medium

  * dh-fortran-mod >= 0.11 to properly remove files on purge.
    Closes: #918000, #915025.
  * Use internal pmix until pmix pkg works.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 07 Jan 2019 21:19:05 +0000

openmpi (3.1.3-7) unstable; urgency=medium

  * Standards-Version: 4.3.0
  * Use dh-fortran-mod and place mod files in $fmoddir/openmpi to avoid
    collision with mpich. Closes: #917133
  * Patch to remove PMIX_MODEX (removed in latest pmix release)

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 01 Jan 2019 13:25:39 +0000

openmpi (3.1.3-6) unstable; urgency=medium

  * Rebuild with dh-fortran-mod >= 0.6 to fix broken postrm script.
    Closes: #916890

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 20 Dec 2018 09:23:45 +0000

openmpi (3.1.3-5) unstable; urgency=medium

  * Use dh-fortran-mod >= 0.4: insert tracking via Fortran-Mod rather than
    Depends. mod file is now placed in /usr/lib/$arch/fortran/gfortran-8
    ($fmoddir) but also in usual place until gfortan reads $fmoddirOA

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 11 Dec 2018 14:14:53 +0000

openmpi (3.1.3-4) unstable; urgency=medium

  * More robust alternatives handling. Closes: #915025
  * Don't call dpkg-parsechangelog in rules

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 07 Dec 2018 13:04:38 +0000

openmpi (3.1.3-3) unstable; urgency=medium

  * Use dh-fortran-mod to track Fortran module version
  * Change symlink /usr/include/openmpi to /usr/include/$ma/openmpi

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 28 Nov 2018 17:08:03 +0000

openmpi (3.1.3-2) unstable; urgency=medium

  * Check if mpi alternatives is corrupt. If so, delete. Closes: #912437
  * openmpi-dev.postinst: don't call update-alt on abort
  * openmpi-bin.postinst: silence grep output on check

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 31 Oct 2018 17:12:52 +0000

openmpi (3.1.3-1) unstable; urgency=medium

  * New upstream release Closes: #902101
  * Drop alioth mailing list (OpenMPI maintainers) from Uploaders.
    Closes: #899289.
  * Openmpi-bin is not labelled M-A: foreign. Closes: #901874
  * preinst, postinst scripts: recast conditionals to allow 'set -e'
  * Add Recommends: libopenmpi-dev to openmpi-bin

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 30 Oct 2018 16:14:16 +0000

openmpi (3.1.3~rc1-1) experimental; urgency=medium

  * New upstream release.
  * Build against libpmix 3.1.0rc1
  * Drop hard-coded xz compression for tarball
  * btl.patch now merged upstream.
  * library soname changes:
    libmpi 40.10.2 -> 40.10.3
    libopen-pal 40.10.2 -> 40.10.3
    libopen-rte 40.10.2 -> 40.10.3
    libmpi_usempif08. 40.10.1 -> 40.10.2

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 24 Oct 2018 16:49:41 +0100

openmpi (3.1.2-7) experimental; urgency=medium

  * Test builtin atomics on riscv64
  * Compile with gcc-7 on ia64 (ICE on gcc8*)

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 17 Oct 2018 12:08:52 +0100

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,16 @@
 Section: net
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Uploaders: Debian Open MPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>,
- Manuel Prinz <manuel@debian.org>
+Uploaders: Manuel Prinz <manuel@debian.org>
 Build-Depends: dpkg-dev (>= 1.16.1~), 
+ dh-fortran-mod (>= 0.11),
  debhelper (>= 11), 
+ gcc-7 [ia64],
  libltdl-dev,
  libevent-dev,
- libpmix-dev (>= 3.0.1-1~),
+ libpmix-dev,
  zlib1g-dev,
- gfortran, gcc (>= 4:5.2.1), 
+ gfortran | fortran-compiler,
  chrpath, 
  libhwloc-dev,
  pkg-config,
@@ -22,7 +23,7 @@
  default-jdk [!hppa !hurd-i386 !ia64 !riscv64] <!stage1>,
  flex
 Build-Conflicts: libmpich-dev, libopenmpi-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: https://www.open-mpi.org/
 Vcs-Browser: https://salsa.debian.org/hpc-team/openmpi
 Vcs-Git: https://salsa.debian.org/hpc-team/openmpi.git -b debian/master
@@ -31,11 +32,15 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, openmpi-common (>= ${source:Version}),
  openssh-client | ssh-client
+Recommends: libopenmpi-dev
 Conflicts: openmpi-bin
-Requires: libopenmpi-dev
-Breaks: libopenmpi-dev (<< 3.0.1~rc2-2)
+Breaks:
+ libopenmpi-dev (<< 3.0.1~rc2-2),
+ mpich (<< 3.3~b1-5),
+ libmpich-dev (<< 3.3~b1-5),
+ lam4-dev (<< 7.1.4-4),
 Replaces: libopenmpi-dev (<< 3.0.1~rc2-2)
-Suggests: gfortran
+Suggests: gfortran | fortran-compiler
 Description: high performance message passing library -- binaries
  Open MPI is a project combining technologies and resources from several other
  projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best
@@ -69,8 +74,13 @@
  libibverbs-dev (>= 1.1.7) [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386], libhwloc-dev,
  openmpi-bin (>= 3.0.0-1)
 Recommends: libcoarrays-openmpi-dev
+Fortran-Mod: ${Fortran-Mod}
 Conflicts: libopenmpi-dev
-Breaks: openmpi-bin (<< 3.0.1~rc2-2)
+Breaks:
+ openmpi-bin (<< 3.0.1~rc2-2),
+ mpich (<< 3.3~b1-5),
+ libmpich-dev (<< 3.3~b1-5),
+ lam4-dev (<< 7.1.4-4),
 Suggests: openmpi-doc
 Description: high performance message passing library -- header files
  Open MPI is a project combining technologies and resources from several other

=== debian/rules ===
--- 
+++ 
@@ -4,8 +4,6 @@
 
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
-
-DEBIAN_VERSION=$(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\-.*\)/\1/p' | sed -e 's/\+.*//; s/^[0-9]://')
 
 DESTDIR:=`pwd`/debian/tmp/
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
@@ -19,10 +17,18 @@
 FABRIC_ARCH:= amd64 i386 
 PSM_ARCH:= amd64 i386
 PSM2_ARCH:= amd64
-BUILTIN_ATOMICS_ARCH:= s390x
+BUILTIN_ATOMICS_ARCH:= s390x riscv64
 NO_CMA_ARCH:= s390x mipsel hppa alpha armhf armel m68k sparc64
 NO_JAVA_ARCH:= hppa hurd-i386 ia64 riscv64
 NO_TEST_ARCH:= hppa hurd-i386
+GCC7_ARCH:= ia64
+
+FORTRAN:=$(shell basename $(shell readlink /etc/alternatives/f95))
+FC ?= $(FORTRAN)
+# Drop '-g' flag with flang. Known failure with 2018122 version
+ifneq ($(filter flang,$(FC)),)
+FCFLAGS=$(shell dpkg-buildflags --get FCLAGS |  sed -e 's/-g //')
+endif
 
 ifeq (sparc,$(DEB_HOST_GNU_CPU))
 	CFLAGS += -mcpu=v9
@@ -36,6 +42,10 @@
 ifeq ($(filter $(NO_VERBS_ARCH),$(DEB_HOST_ARCH)),)
 	VERBS := --with-verbs
 endif	
+# Use gcc-7 on ia64; ICE on gcc 8.*
+ifneq ($(filter $(GCC7_ARCH),$(DEB_HOST_ARCH)),)
+export CC=gcc-7
+endif
 ifneq ($(filter $(BUILTIN_ATOMICS_ARCH),$(DEB_HOST_ARCH)),)
 	ENABLE_BUILTIN_ATOMICS:= --enable-builtin-atomics
 endif
@@ -70,7 +80,7 @@
 
 
 %:
-	dh $@ --no-parallel
+	dh $@ --no-parallel --with=fortran_mod
 
 override_dh_auto_clean:
 	dh_clean
@@ -92,7 +102,7 @@
 		--disable-silent-rules \
 		--disable-wrapper-runpath \
 		--with-package-string="Debian OpenMPI" \
-		$(VERBS) $(FABRIC) $(PSM) $(PSM2) $(CMA) $(PMIX) \
+		$(VERBS) $(FABRIC) $(PSM) $(PSM2) $(CMA) \
 		$(ENABLE_BUILTIN_ATOMICS) \
 		$(JAVA) \
 		$(STATIC_CONFIG_PARAMS) \
@@ -195,6 +205,3 @@
 		dh_link -p libopenmpi3 ${LIBDIR}/openmpi/lib/libmpi_java.so.40.10.0 ${LIBDIR}/libmpi_java.so.40.10.0 ; \
 		dh_link -p libopenmpi-dev ${LIBDIR}/libmpi_java.so.40	${LIBDIR}/libmpi_java.so ; \
 	fi
-	if test -f debian/tmp/${LIBDIR}/openmpi/lib/libmca_common_monitoring.so.50.0.0 ; then  \
-		cp -a debian/tmp/${LIBDIR}/openmpi/lib/libmca_common_monitoring.so.50.0.0 \
-			debian/libopenmpi3/${LIBDIR}/openmpi/lib/libmca_common_monitoring.so.50.0.0 ; \

## openmpi 4.0.2

=== debian/changelog ===
openmpi (4.0.2-5+rpi1) bullseye-staging; urgency=medium

  [changes brought forward from 2.1.1-6+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Wed, 05 Jul 2017 00:52:53 +0000]
  * Modify arm "detection" for Raspbian.
  * Partially fix clean target

 -- Raspbian forward porter <root@raspbian.org>  Fri, 27 Dec 2019 11:17:41 +0000

openmpi (4.0.2-5) unstable; urgency=medium

  * Fix typos in d/changelog
  * Ship orte-server. Closes: #946542

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 18 Dec 2019 13:41:29 +0000

openmpi (4.0.2-4) unstable; urgency=medium

  * Version numbers on libs changed:
   - libmpi_java.so now version 40.20.0
   - libmca_common_monitoring.so now 50.10.0
   - libmca_common_ompio.so now 41.19.2
   - libmca_common_verbs.so now 40.20.0 
   - libmca_common_ofi.so, liboshmem.so no longer produced
   - Closes: #945170, 
  * Close old bug: Closes #945121
  * Update postinst scripts, remove preinst scripts; remove stuff no longer
    needed post buster

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 21 Nov 2019 14:35:36 +0000

openmpi (4.0.2-3) unstable; urgency=medium

  * Add dependency on libevent-dev to libopenmpi-dev. Closes: #933738
  * Drop deprecated Fortran-Mod: clause from d/control. Closes: #916860
  * Enable java support for riscv64. Closes: #933738
  * dh_fortran_mod now adds Fortran dependencies. Closes: #916159
  * As of last upload, openmpi no longer prints warnings to stderr
    by default. Closes: #814451
  * Recent openmpi works in chroot. Closes: #494046
  * OpenMPI4 works with hwloc2. Closes: #916794.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 20 Nov 2019 09:24:14 +0000

openmpi (4.0.2-2) unstable; urgency=medium

  * Move to unstable. Closes: #941996
  * Set OMPI_MCA_btl_base_warn_component_unused=0 by default to silence 
    warnings. Add README.Debian to say so.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 19 Nov 2019 11:55:49 +0000

openmpi (4.0.2-1) experimental; urgency=medium

  * New upstream release
   - libmpi_usempi_ignore_tkr.so now .40.20.0 
   - libompitrace.so now 40.20.0

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 22 Oct 2019 18:04:21 +0100

openmpi (4.0.2~rc1-1) experimental; urgency=medium

  * New upstream release
   - libmpi_cxx.so, libmpi_usempif08.so  now 40.20.1
   - libmpi_mpifh, libmpi.so now 40.20.2
   - libopen-pal, libopen-rte now 40.20.2

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 09 Sep 2019 06:46:16 +0100

openmpi (4.0.1-1) experimental; urgency=medium

  * New upstream release
   -  orte-ps, orte-top, orte-server, orte-dvm, prun no longer built.
   - libmca_common_sm now 40.20.0
   - libmpi.so, libmpi_mpifh,libopen-rte,libopen-pal  now 40.20.1
  * Undo --no-parallel.
  * Standards-Version: 4.4.0
  * Use debhelper-compat (= 12)
  * Drop B-D on gcc7 for ia64 (no longer a release arch)

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 21 Jul 2019 11:20:58 +0100

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,7 @@
 Uploaders: Manuel Prinz <manuel@debian.org>
 Build-Depends: dpkg-dev (>= 1.16.1~), 
  dh-fortran-mod (>= 0.11),
- debhelper (>= 11), 
- gcc-7 [ia64],
+ debhelper-compat (= 12), 
  libltdl-dev,
  libevent-dev,
  libpmix-dev,
@@ -23,7 +22,7 @@
  default-jdk [!hppa !hurd-i386 !ia64 !riscv64] <!stage1>,
  flex
 Build-Conflicts: libmpich-dev, libopenmpi-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1.0
 Homepage: https://www.open-mpi.org/
 Vcs-Browser: https://salsa.debian.org/hpc-team/openmpi
 Vcs-Git: https://salsa.debian.org/hpc-team/openmpi.git -b debian/master
@@ -34,6 +33,7 @@
  openssh-client | ssh-client
 Recommends: libopenmpi-dev
 Conflicts: openmpi-bin
+Multi-Arch: foreign
 Breaks:
  libopenmpi-dev (<< 3.0.1~rc2-2),
  mpich (<< 3.3~b1-5),
@@ -72,9 +72,9 @@
  libopenmpi3 (= ${binary:Version}), 
  openmpi-common (>= ${source:Version}), 
  libibverbs-dev (>= 1.1.7) [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386], libhwloc-dev,
+ libevent-dev, 
  openmpi-bin (>= 3.0.0-1)
 Recommends: libcoarrays-openmpi-dev
-Fortran-Mod: ${Fortran-Mod}
 Conflicts: libopenmpi-dev
 Breaks:
  openmpi-bin (<< 3.0.1~rc2-2),

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
 AUTOGENERATED:= libopenmpi3.links libopenmpi-dev.links libopenmpi-dev.postinst \
-  libopenmpi-dev.prerm openmpi-bin.preinst libopenmpi-dev.preinst
+  libopenmpi-dev.prerm 
 
 ### Arch-specific stuff
 # No ibverbs support available on kFreeBSD, Hurd
@@ -19,7 +19,7 @@
 PSM2_ARCH:= amd64
 BUILTIN_ATOMICS_ARCH:= s390x riscv64
 NO_CMA_ARCH:= s390x mipsel hppa alpha armhf armel m68k sparc64
-NO_JAVA_ARCH:= hppa hurd-i386 ia64 riscv64
+NO_JAVA_ARCH:= hppa hurd-i386 ia64
 NO_TEST_ARCH:= hppa hurd-i386
 GCC7_ARCH:= ia64
 
@@ -80,7 +80,7 @@
 
 
 %:
-	dh $@ --no-parallel --with=fortran_mod
+	dh $@ --with=fortran_mod
 
 override_dh_auto_clean:
 	dh_clean
@@ -89,6 +89,12 @@
 	find . -type l -delete
 	find . -name '*.o' -delete
 	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
+	rm -f `find test/ -type f ! -name '*.*' ! -name 'run_tests'`
+	rm -f `find . -name '*.a'`
+	rm -f `find . -name '*.class'`
+	rm -f `find . -name '*.mod'`
+	rm -f `find . -name '*.jar'`
+	rm -f `find orte/tools/ -type f ! -name '*.*'`
 
 override_dh_update_autotools_config:
 	(cd config && autom4te --language=m4sh opal_get_version.m4sh -o opal_get_version.sh)
@@ -120,14 +126,6 @@
 		--sysconfdir=/etc/openmpi 		\
 		--libdir=\$${prefix}/lib/${DEB_HOST_MULTIARCH}/openmpi/lib	\
 		--includedir=\$${prefix}/lib/${DEB_HOST_MULTIARCH}/openmpi/include 
-
-# Extra debugging for non-deterministic FTBFS on some archs
-override_dh_auto_build:
-	dh_auto_build || ( \
-		cat config.log ; \
-		cat libtool ; \
-		find . -name '*.la' -exec cat {} \; \
-		)
 
 override_dh_install:
 	# Strip rpath info from all executables and libraries.
@@ -190,18 +188,19 @@
 		cp -a debian/tmp/usr/bin/oshmem_info  debian/openmpi-bin//usr/bin/ ; \
 		cp -a debian/tmp/usr/bin/oshcc	 debian/libopenmpi-dev/usr/bin   ; \
 		cp -a debian/tmp/usr/bin/oshfort   debian/libopenmpi-dev/usr/bin   ; \
-		cp -a debian/tmp/${LIBDIR}/openmpi/lib/liboshmem.so.40.10.1 debian/libopenmpi3/${LIBDIR}/openmpi/lib ; \
 		cp -a debian/tmp/usr/share/man/man1/oshcc.1 debian/libopenmpi-dev/usr/share/man/man1 ; \
 		cp -a debian/tmp/usr/share/man/man1/oshfort.1 debian/libopenmpi-dev/usr/share/man/man1 ; \
 		cp -a debian/tmp/usr/share/man/man1/oshrun.1 debian/openmpi-bin/usr/share/man/man1 ; \
 		cp -a debian/tmp/usr/share/man/man1/oshmem_info.1 debian/openmpi-bin/usr/share/man/man1 ; \
-		dh_link -p libopenmpi-dev	${LIBDIR}/liboshmem.so.40  ${LIBDIR}/liboshmem.so ; \
-		dh_link -p libopenmpi3 ${LIBDIR}/openmpi/lib/liboshmem.so.40.10.1  ${LIBDIR}/liboshmem.so.40 ; \
-	fi
-	if test -f debian/tmp/${LIBDIR}/openmpi/lib/libmpi_java.so.40.10.0 ; then \
-		cp -a debian/tmp/${LIBDIR}/openmpi/lib/libmpi_java.so.40.10.0 \
-			debian/libopenmpi3/${LIBDIR}/openmpi/lib/libmpi_java.so.40.10.0 ; \
-		dh_link -p libopenmpi3 ${LIBDIR}/libmpi_java.so.40.10.0  ${LIBDIR}/libmpi_java.so.40 ; \
-		dh_link -p libopenmpi3 ${LIBDIR}/openmpi/lib/libmpi_java.so.40.10.0 ${LIBDIR}/libmpi_java.so.40.10.0 ; \
+	fi
+	# cp -a debian/tmp/${LIBDIR}/openmpi/lib/liboshmem.so.40.20.0 debian/libopenmpi3/${LIBDIR}/openmpi/lib ; 
+	# dh_link -p libopenmpi-dev	${LIBDIR}/liboshmem.so.40  ${LIBDIR}/liboshmem.so ; 
+	# dh_link -p libopenmpi3 ${LIBDIR}/openmpi/lib/liboshmem.so.40.20.0  ${LIBDIR}/liboshmem.so.40 ; 
+	if test -f debian/tmp/${LIBDIR}/openmpi/lib/libmpi_java.so.40.20.0 ; then \
+		cp -a debian/tmp/${LIBDIR}/openmpi/lib/libmpi_java.so.40.20.0 \
+			debian/libopenmpi3/${LIBDIR}/openmpi/lib/libmpi_java.so.40.20.0 ; \
+		dh_link -p libopenmpi3 ${LIBDIR}/libmpi_java.so.40.20.0  ${LIBDIR}/libmpi_java.so.40 ; \
+		dh_link -p libopenmpi3 ${LIBDIR}/openmpi/lib/libmpi_java.so.40.20.0 ${LIBDIR}/libmpi_java.so.40.20.0 ; \
 		dh_link -p libopenmpi-dev ${LIBDIR}/libmpi_java.so.40	${LIBDIR}/libmpi_java.so ; \
 	fi
+	if test -f debian/tmp/${LIBDIR}/openmpi/lib/libmca_common_monitoring.so.50.10.0 ; then  \
